```mermaid
graph TB
  start("Start")
  reserve["Reserve a contribution"]
  submitCode["Submit/update code and MR"]
  hasComments{"Has comments"}
  provideComment["Provide comments on Portal"]
  reject["Declare rejected"]
  approve["Declare approved"]
  provideComment["Provide comments on Portal"]
  approval{"Apporoval process"}
  submitContrib["Flag MR as Ready;Submit or revise Contribution"]
  closeMR["Close MR"]
  applyMR["Apply MR"]
  newDraft{"New draft?"}
  makeDraft["Tag, Update, Upload Draft"]
  stop("Stop")
  start-->reserve
  start-->submitCode
  reserve-->submitCode
  submitCode-->hasComments
  hasComments--Yes-->submitCode
  hasComments--No-->submitContrib
  submitContrib-->approval
  approval--Consensus-->approve
  approval-->reject
  approve-->applyMR
  approval--"Rev needed"-->provideComment
  provideComment-->submitContrib
  reject-->closeMR
  closeMR-->stop
  applyMR-->newDraft
  newDraft--Yes-->makeDraft
  newDraft--No-->stop
  makeDraft-->stop
```

