```mermaid
graph TB
    submitMR-->hasComments
    postComment-->submitCode
    submitContrib-->approval
    approval--Consensus-->approve
    approval-->reject
    approve-->applyMR
    reject-->closeMR
    submitMR-->flagMR
    subgraph Rapporteur
    closeMR["Close MR"]
    applyMR["Apply MR"]
    newDraft{"New draft?"}
    tagDraft["Tag Draft"]
    updateDraft["Update draft"]
    uploadDraft["Upload draft"]
    stop("Stop")
    closeMR-->stop
    applyMR-->newDraft
    newDraft--Yes-->tagDraft
    newDraft--No-->stop
    tagDraft-->updateDraft
    updateDraft-->uploadDraft
    uploadDraft-->stop
    end
    subgraph TB Chairman
    reject["Declare rejected"]
    approve["Declare approved"]
    end
    subgraph TB Delegate Approval
    provideComment["Provide comments on Portal"]
    approval{"Apporoval process"}
    approval--"Rev needed"-->provideComment
    end
    subgraph Contributor    
    flagMR["Flag MR as Ready"]
    submitContrib["Submit or revise Contribution"]
    flagMR-->submitContrib
    end
    subgraph TB Delegate Comments
    postComment["Post comment on Forge"]
    hasComments{"Has comments"}
    provideComment["Provide comments on Portal"]
    hasComments--Yes-->postComment
    end
    subgraph ContribInitiator
    reserve["Reserve a contribution"]
    submitCode["Submit changes"]
    submitMR["Submit Merge Request (MR)"]
    reserve-->submitCode
    submitCode-->submitMR
    end
```